eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}' && eval 'exec perl -S $0 $argv:q'
  if 0;

## Parse .log file from TeX and list included files.
## Note: included files will include the main tex file.
##       that is safe, I think.  It is one of the relevant files.
##
##   3 May 2001 JCC
##     Command_line handling
##  25 Apr 2001 JCC
##     First version

use FileHandle;
use File::Basename;

if ( $#ARGV < 0 ) {
    print "Usage: get-includes.pl basename\n";
    print "gets filenames from basename.log\n";
    exit;
}

$given_name = shift;
$log_file = "$given_name.log";

($base_name) = fileparse ($given_name, '\..*$');
# Aux file is always in same directory as log file, with no path.
$aux_file = "$base_name.aux";

@include_list = ();

open(log_file) || die "LatexMk: Couldn't open log file [$log_file]\n";
$line_number = 0;
$graphic_line = 0;
LINE:
while(<log_file>) { 
    $line_number++;
    if ( $graphic_line ) {
        if ( /<(use )?(.*?)>/ ) {
           push @include_list, $2;
           $graphic_line = 0;
        }
        next LINE;
    }
    if ( $line_number == 1 ){
	if ( /^This is / ) {
	    # First line OK\n";
            next LINE;
        } else {
            die "Error on first line of \"$log_file\".  This is not a TeX log file.\n$_";
	}
    }
    if ( /^Output written on / ) {
        # Latex message
	next LINE;
    }
    if ( /^Underfull / ) {
        # Latex error/warning
	next LINE;
    }
    if ( /^Overfull / ) {
        # Latex error/warning
	next LINE;
    }
    if ( /^\(Font\)/ ) {
	# Font info line
        next LINE;
    }
    if ( /^Package: / ) {
        # Package sign-on line
	next LINE;
    }
    if ( /^File: / ) {
        if ( /Graphic file / ) {
            warn "File:...Graphic File seen, but no include was found.\n"
              if $graphical_line == 1;

	    $graphic_line = 1;
            next LINE;
	} else {
           # Package sign-on line
	   next LINE;
       }
    }

    INCLUDE_NAME:
    while ( /\(([^\)\s\[]*)/ ) {
        $_ = $';
        $include_name = $1;
        if ( "$include_name" eq "[]" ) {
           # Part of overfull hbox message
        } elsif ( "$include_name" eq "$aux_file" ) {
           # .aux file is not a genuinely included file
	} else {
           push @include_list, $include_name;
        }
    }
}

close(log_file);

@non_existent = ();
@existent = ();

foreach (@include_list) {
    if ( -e $_ ) {
       push @existent, $_;
    } else {
       push @non_existent, $_;
    }
}

print "$#include_list included files, of which $#existent exist.\n";

print "Included files that exist:\n";
foreach (@existent) {
    print "   $_\n";
}

if ( $#non_existent > 0 ) {
   print "Included files that appear NOT to exist:\n";
   foreach (@non_existent) {
       print "   $_\n";
   }
}
